disp(strcat('Creating',{' '},num2str(Ntrials),{' '},'Samples. Shift:',{' '},num2str(shift)))
%% SETTINGS
border=5;
Normalize=1;
%% RESET DATA

%--- SAMPLE-2
FTHS_v2_s=zeros(NTH2,Ntrials);
FTHS_v2_h=zeros(NTH2,Ntrials);
FTHS_v2_v=zeros(NTH2,Ntrials);

FL4S_v2_s=zeros(NTH2,Ntrials);
FL4S_v2_h=zeros(NTH2,Ntrials);
FL4S_v2_v=zeros(NTH2,Ntrials);

%--- SAMPLE-3
FTHS_v3_s=zeros(NTH2,Ntrials);
FTHS_v3_h=zeros(NTH2,Ntrials);
FTHS_v3_v=zeros(NTH2,Ntrials);

FL4S_v3_s=zeros(NTH2,Ntrials);
FL4S_v3_h=zeros(NTH2,Ntrials);
FL4S_v3_v=zeros(NTH2,Ntrials);


%% #2 Sample Datasets (Train)
for trial = 1 : Ntrials
    img = fix(1 +  Nimages1 * rand);
    imgs(trial)=img;
    
    ixl = fix(1+border + (rangex-2*border-Nwindow_x1) * rand);	iyt = fix(1+border + (rangey-2*border-Nwindow_y1) * rand);
    ixr = ixl + Nwindow_x1;		iyb = iyt + Nwindow_y1;
    image2D = reshape(images(:, img), Npxy, Npxx);
    
    window2D = image2D(iyt : iyb, ixl : ixr); % normal
    windowbig=image2D(iyt-border : iyb+border, ixl-border : ixr+border);
    
    
    horizantal = fspecial('motion', shift,hangle);
    vertical = fspecial('motion', shift,vangle);
    windowh = imfilter(windowbig, horizantal);
    windowv = imfilter(windowbig, vertical);
    
    close all
    
    
    
    windowh=windowh(1+border : size(windowh,1)-border, 1+border : size(windowh,1)-border);
%     imshow(windowh)
%     figure
    windowh = reshape(windowh, Nwindow, 1);
    
    windowv=windowv(1+border : size(windowv,1)-border, 1+border : size(windowv,1)-border);
%     imshow(windowv)
%     figure
    windowv = reshape(windowv, Nwindow, 1);
    
%     imshow(windowbig)
%     pause
    
    
    
    windows=window2D;
    windows = reshape(windows, Nwindow, 1);
    %======== FTHS: NORMAL ========================
    FTH = zeros(NTH2, 1);
    F = WPX * windows;
    FF = F + SPONT;
    FTH(1 : NTH) = FF.*(FF > 0);
    FF = SPONT - F;
    FTH(NTH+1 : NTH2) = FF.*(FF > 0);
    FTHlength = sqrt(sum(FTH.^2));	% stimulus vector length
    if Normalize==1
        FTHS_v2_s(:, trial) = FTH/FTHlength;
    else
        FTHS_v2_s(:, trial) = FTH;%/FTHlength;
    end
    %======== FL4S: NORMAL ========================
    FAFF = WTH * FTH;		% Compute thalamic input to L4 cells.
    FAFFthr = FAFF - theta * FTHlength;
    VL4 = theta25 * FAFFthr;	% membrane potential
    FL4 = max(0, VL4);		% output (rectified potential)
    for irev = 1 : Nrevs	% Do activity reverberations
        FLAT = WLAT * FL4;
        VL4 = 0.75 * VL4 + theta25 * (FAFFthr - lambda * FLAT);
        FL4 = max(0, VL4);
    end
    if Normalize==1
        FL4S_v2_s(:, trial) = FL4/norm(FL4);
    else
        FL4S_v2_s(:, trial) = FL4;%/norm(FL4);
    end
    %======== FTHS: NORMAL ========================
    FTH = zeros(NTH2, 1);
    F = WPX * windowh;
    FF = F + SPONT;
    FTH(1 : NTH) = FF.*(FF > 0);
    FF = SPONT - F;
    FTH(NTH+1 : NTH2) = FF.*(FF > 0);
    FTHlength = sqrt(sum(FTH.^2));	% stimulus vector length
    if Normalize==1
        FTHS_v2_h(:, trial) = FTH/FTHlength;
    else
        FTHS_v2_h(:, trial) = FTH;%/FTHlength;
    end
    %======== FL4S: NORMAL ========================
    FAFF = WTH * FTH;		% Compute thalamic input to L4 cells.
    FAFFthr = FAFF - theta * FTHlength;
    VL4 = theta25 * FAFFthr;	% membrane potential
    FL4 = max(0, VL4);		% output (rectified potential)
    for irev = 1 : Nrevs	% Do activity reverberations
        FLAT = WLAT * FL4;
        VL4 = 0.75 * VL4 + theta25 * (FAFFthr - lambda * FLAT);
        FL4 = max(0, VL4);
    end
    if Normalize==1
        FL4S_v2_h(:, trial) = FL4/norm(FL4);
    else
        FL4S_v2_h(:, trial) = FL4;%/norm(FL4);
    end
    %==========================================================
    %======== FTHS: NORMAL ========================
    FTH = zeros(NTH2, 1);
    F = WPX * windowv;
    FF = F + SPONT;
    FTH(1 : NTH) = FF.*(FF > 0);
    FF = SPONT - F;
    FTH(NTH+1 : NTH2) = FF.*(FF > 0);
    FTHlength = sqrt(sum(FTH.^2));	% stimulus vector length
    if Normalize==1
        FTHS_v2_v(:, trial) = FTH/FTHlength;
    else
        FTHS_v2_v(:, trial) = FTH;%/FTHlength;
    end
    %======== FL4S: NORMAL ========================
    FAFF = WTH * FTH;		% Compute thalamic input to L4 cells.
    FAFFthr = FAFF - theta * FTHlength;
    VL4 = theta25 * FAFFthr;	% membrane potential
    FL4 = max(0, VL4);		% output (rectified potential)
    for irev = 1 : Nrevs	% Do activity reverberations
        FLAT = WLAT * FL4;
        VL4 = 0.75 * VL4 + theta25 * (FAFFthr - lambda * FLAT);
        FL4 = max(0, VL4);
    end
    if Normalize==1
        FL4S_v2_v(:, trial) = FL4/norm(FL4);
    else
        FL4S_v2_v(:, trial) = FL4;%/norm(FL4);
    end
end	% end of a trial
%% #3 Sample Datasets (Test)
for trial = 1 : Ntrials
    img = fix(1 +  Nimages1 * rand);
    imgs(trial)=img;
    
    ixl = fix(1+border + (rangex-2*border-Nwindow_x1) * rand);	iyt = fix(1+border + (rangey-2*border-Nwindow_y1) * rand);
    ixr = ixl + Nwindow_x1;		iyb = iyt + Nwindow_y1;
    image2D = reshape(images(:, img), Npxy, Npxx);
    
    window2D = image2D(iyt : iyb, ixl : ixr); % normal
    windowbig=image2D(iyt-border : iyb+border, ixl-border : ixr+border);
    
    
    horizantal = fspecial('motion', shift,hangle);
    vertical = fspecial('motion', shift,vangle);
    windowh = imfilter(windowbig, horizantal);
    windowv = imfilter(windowbig, vertical);
    
    windowh=windowh(1+border : size(windowh,1)-border, 1+border : size(windowh,1)-border);
    windowh = reshape(windowh, Nwindow, 1);
    windowv=windowv(1+border : size(windowv,1)-border, 1+border : size(windowv,1)-border);
    windowv = reshape(windowv, Nwindow, 1);
    
    windows=window2D;
    windows = reshape(windows, Nwindow, 1);
    %======== FTHS: NORMAL ========================
    FTH = zeros(NTH2, 1);
    F = WPX * windows;
    FF = F + SPONT;
    FTH(1 : NTH) = FF.*(FF > 0);
    FF = SPONT - F;
    FTH(NTH+1 : NTH2) = FF.*(FF > 0);
    FTHlength = sqrt(sum(FTH.^2));	% stimulus vector length
    if Normalize==1
        FTHS_v3_s(:, trial) = FTH/FTHlength;
    else
        FTHS_v3_s(:, trial) = FTH;%/FTHlength;
    end
    %======== FL4S: NORMAL ========================
    FAFF = WTH * FTH;		% Compute thalamic input to L4 cells.
    FAFFthr = FAFF - theta * FTHlength;
    VL4 = theta25 * FAFFthr;	% membrane potential
    FL4 = max(0, VL4);		% output (rectified potential)
    for irev = 1 : Nrevs	% Do activity reverberations
        FLAT = WLAT * FL4;
        VL4 = 0.75 * VL4 + theta25 * (FAFFthr - lambda * FLAT);
        FL4 = max(0, VL4);
    end
    if Normalize==1
        FL4S_v3_s(:, trial) = FL4/norm(FL4);
    else
        FL4S_v3_s(:, trial) = FL4;%/norm(FL4);
    end
    %======== FTHS: NORMAL ========================
    FTH = zeros(NTH2, 1);
    F = WPX * windowh;
    FF = F + SPONT;
    FTH(1 : NTH) = FF.*(FF > 0);
    FF = SPONT - F;
    FTH(NTH+1 : NTH2) = FF.*(FF > 0);
    FTHlength = sqrt(sum(FTH.^2));	% stimulus vector length
    if Normalize==1
        FTHS_v3_h(:, trial) = FTH/FTHlength;
    else
        FTHS_v3_h(:, trial) = FTH;%/FTHlength;
    end
    %======== FL4S: NORMAL ========================
    FAFF = WTH * FTH;		% Compute thalamic input to L4 cells.
    FAFFthr = FAFF - theta * FTHlength;
    VL4 = theta25 * FAFFthr;	% membrane potential
    FL4 = max(0, VL4);		% output (rectified potential)
    for irev = 1 : Nrevs	% Do activity reverberations
        FLAT = WLAT * FL4;
        VL4 = 0.75 * VL4 + theta25 * (FAFFthr - lambda * FLAT);
        FL4 = max(0, VL4);
    end
    if Normalize==1
        FL4S_v3_h(:, trial) = FL4/norm(FL4);
    else
        FL4S_v3_h(:, trial) = FL4;%/norm(FL4);
    end
    %==========================================================
    %======== FTHS: NORMAL ========================
    FTH = zeros(NTH2, 1);
    F = WPX * windowv;
    FF = F + SPONT;
    FTH(1 : NTH) = FF.*(FF > 0);
    FF = SPONT - F;
    FTH(NTH+1 : NTH2) = FF.*(FF > 0);
    FTHlength = sqrt(sum(FTH.^2));	% stimulus vector length
    if Normalize==1
        FTHS_v3_v(:, trial) = FTH/FTHlength;
    else
        FTHS_v3_v(:, trial) = FTH;%/FTHlength;
    end
    %======== FL4S: NORMAL ========================
    FAFF = WTH * FTH;		% Compute thalamic input to L4 cells.
    FAFFthr = FAFF - theta * FTHlength;
    VL4 = theta25 * FAFFthr;	% membrane potential
    FL4 = max(0, VL4);		% output (rectified potential)
    for irev = 1 : Nrevs	% Do activity reverberations
        FLAT = WLAT * FL4;
        VL4 = 0.75 * VL4 + theta25 * (FAFFthr - lambda * FLAT);
        FL4 = max(0, VL4);
    end
    if Normalize==1
        FL4S_v3_v(:, trial) = FL4/norm(FL4);
    else
        FL4S_v3_v(:, trial) = FL4;%/norm(FL4);
    end
end	% end of a trial
%%
disp('Done')