disp(strcat('Creating Other Purpose',{' '},num2str(Ntrials),{' '},'Samples.'))
%% SETTINGS
border=5;
Normalize=0;
%% RESET DATA

%--- SAMPLE-1
FTHS_v1_s=zeros(NTH2,Ntrials);
FL4S_v1_s=zeros(NTH2,Ntrials);

%% #1 Sample Datasets (Other Purpose)
for trial = 1 : Ntrials
    img = fix(1 +  Nimages1 * rand);
    imgs(trial)=img;
    
    ixl = fix(1+border + (rangex-2*border-Nwindow_x1) * rand);	iyt = fix(1+border + (rangey-2*border-Nwindow_y1) * rand);
    ixr = ixl + Nwindow_x1;		iyb = iyt + Nwindow_y1;
    image2D = reshape(images(:, img), Npxy, Npxx);
    
    window2D = image2D(iyt : iyb, ixl : ixr); % normal
    windowbig=image2D(iyt-border : iyb+border, ixl-border : ixr+border);
    
    windows=window2D;
    windows = reshape(windows, Nwindow, 1);
    %======== FTHS: NORMAL ========================
    FTH = zeros(NTH2, 1);
    F = WPX * windows;
    FF = F + SPONT;
    FTH(1 : NTH) = FF.*(FF > 0);
    FF = SPONT - F;
    FTH(NTH+1 : NTH2) = FF.*(FF > 0);
    FTHlength = sqrt(sum(FTH.^2));	% stimulus vector length
    if Normalize==1
        FTHS_v1_s(:, trial) = FTH/FTHlength;
    else
        FTHS_v1_s(:, trial) = FTH;%/FTHlength;
    end
    %======== FL4S: NORMAL ========================
    FAFF = WTH * FTH;		% Compute thalamic input to L4 cells.
    FAFFthr = FAFF - theta * FTHlength;
    VL4 = theta25 * FAFFthr;	% membrane potential
    FL4 = max(0, VL4);		% output (rectified potential)
    for irev = 1 : Nrevs	% Do activity reverberations
        FLAT = WLAT * FL4;
        VL4 = 0.75 * VL4 + theta25 * (FAFFthr - lambda * FLAT);
        FL4 = max(0, VL4);
    end
    if Normalize==1
        FL4S_v1_s(:, trial) = FL4/norm(FL4);
    else
        FL4S_v1_s(:, trial) = FL4;%/norm(FL4);
    end
end	% end of a trial

disp('Done')