% Display LGN representation of the image patch
t=0.5 * tan(30 * pi / 180);
tt=sqrt(0.75) - t;
corners = [0 0.5 0.5 0 -0.5 -0.5; tt t -t -tt -t t];
corners = corners';


color_scale = 1.4;	% change the scale, if not enough contrast
figure
for ith = 1 : NTH
    x = corners(:, 1) + TH_coord(ith, 1);
    y = corners(:, 2) + TH_coord(ith, 2);
    F = FTH(ith + NTH);
    if (FTH(ith) > F)
        F = -FTH(ith);
    end
    col = 0.5 - color_scale * F;
    if (col < 0)
        col = 0;
    end
    if (col > 1)
        col = 1;
    end
    colorspec = [col col col];
    fill(x,y,colorspec,'EdgeColor',colorspec)
    hold on
end
axis square
axis([0 25 0 25])
