function [ output ] = RadComp( data, class_size )
% data column feature, row sample

b=sort(randperm(size(data,1),class_size));
data2=data(b',:)';
for trial=1:size(data2,1)
    classes=rand(1, class_size);
    for i=1:size(data,2)
        temp(i)=corr2(data2(i,:),classes);
    end
    temp(find(isnan(temp))) = 0;
    temp2=temp*data2;
    perf(trial) = (corr2(temp2, classes));
end
output=mean((perf.^2).*sign(perf));
end

% bir data se 100 lk mesela
% 100 pencere se her birisine random de?er ata.-1 1 aras?nda continous
% her bir de?i?ken ile korelasyon hesapla
% sonra onlar? topla