% Load images
load yard;		% load images into array called "dat"
Nimages = dat(1);	Npxx = dat(2);	Npxy = dat(3);
images = zeros(Npxx*Npxy, Nimages);	image2D = zeros(Npxy, Npxx);
mimages = zeros(Npxx*Npxy, Nimages);
for img = 1 : Nimages
    n1 = 2 + img * 2 + (img - 1) * Npxx * Npxy;
    n2 = n1 + Npxx * Npxy - 1;
    images(:, img) = dat(n1 : n2);
    image2D = reshape(images(:, img), Npxx, Npxy);  image2D = image2D';
    images(:, img) = reshape(image2D, Npxx*Npxy, 1);
end
imagesrnd=rand(Npxx*Npxy,5);
% ______________________________________________________________________
% RF and L4 parameters
u = 1;	SIGMAc = 0.8833 * u;	SIGMAm = 3 * SIGMAc;
Ccenter = 1.0 / (2 * pi * SIGMAc^2); Cmargin = 1.0 / (2 * pi * SIGMAm^2);
RFradius = 3 * SIGMAm;	RFradius2 = RFradius ^ 2;

% NL4=182;
% theta = 0.65;	Nrevs = 20;	lambda = 1;

theta25 = 0.25 / (1 - theta);				SPONT = 0.1;
% ______________________________________________________________________
% Load thalamic centers and define window size
load TH_coord;
Nrings = 6;	NTH = 91;	NTH2 = 2 * NTH;
Nwindow_x = fix((Nrings * 2 - 2) * u + 2 * RFradius +1) - 1;
Nwindow_y = fix((Nrings * 2 - 2) * u * sqrt(0.75) + 2 * RFradius + 1);
Nwindow_x1 = Nwindow_x - 1;		Nwindow_y1 = Nwindow_y - 1;
rangex = Npxx - Nwindow_x - 3;	rangey = Npxy - Nwindow_y - 3;
Nimages1 = Nimages - 0.0001;		Nwindow = Nwindow_x * Nwindow_y;
% _____________________________________________________________________
% Load connection weights from each pixel in the window to all TH cells
WPX = zeros(NTH, Nwindow);	load WPX;
% Load thalamocortical and lateral connection weights.
WTH = zeros(NL4, NTH2);
% _____________________________________________________________________
FTH = zeros(NTH2, 1);
FL4 = zeros(NL4, 1); 	% output of L4 cells
VL4 = zeros(NL4, 1); 	% membrane potential of L4 cells
%====================================================================
