function draw_RBF( data,gamma )
%draw_RBF by Erdem Isenkul
%   data: data matrix, columns are features-rows are samples
%   gamma: RBF gamma value to draw
aa=squareform(pdist(data)).^2;
K=exp(-aa./(2*gamma.^2));
hist(K(:),30);
end

